image: continuumio/miniconda3:latest

stages:
  - bootstrap
  - build
  - test
  - deploy

before_script:
  - apt-get install -y gcc g++
  - export CONDA_BASE=$(conda info --base)
  - source $CONDA_BASE/etc/profile.d/conda.sh
  - conda env create
  - conda activate meson-bro

just-configure:
  stage: bootstrap
  script:
    - meson build/

build:
  stage: build
  script:
    - meson build/
    - meson compile -C build/

build-unit-tests:
  stage: test
  script:
    - meson build/ -Dtests=true
    - meson test -C build/

# Test that the library is installed correctly and can be found by cmake
downstream-test:
  stage: deploy
  script:
    - meson build/build/ --prefix=$CONDA_PREFIX --libdir=lib
    - meson install -C build/build/
    - meson build/downstream/ test/downstream/
    - meson test -C build/downstream
